(function() {'use strict';

    var Constants = [{
        ID: 20,
        FixRelated: { 
            type: 'privacy_update',
            id: '0',
            valueSet: [300645083384735, 291667064279714, 286958161406148],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:22
        }
        // Description: 'Who can see your future posts?'
    }, {
        ID: 22,
        FixRelated: {
            type: 'privacy_update',
            id: '8787820733',
            valueSet: [300645083384735, 275425949243301, 291667064279714],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:11
        }
        // Description: 'Who can look you up using the email address you provided?'
    }, {
        ID: 23,
        FixRelated: {
            type: 'privacy_update',
            id: '8787815733',
            valueSet: [300645083384735, 275425949243301, 291667064279714],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:11
        }
        // Description: 'Who can look you up using the phone number you provided?'
    }, {
        ID: 24,
        FixRelated: {
            type: 'public_search',
            valueSet: [0, 1],
            url: '/ajax/settings_page/search_filters.php'
        }
        // Description: 'Let other search engines link to your timeline'
    }, {
        ID: 31,
        FixRelated: {
            type: 'timelineReview',
            valueSet: [1, 0],
            url: '/ajax/settings/timeline/review.php'
        }
        // Description: 'Review posts friends tag you in before they appear on your timeline'
    }, {
        ID: 33,
        FixRelated: {
            type: 'privacy_update',
            id: '8787530733',
            valueSet: [300645083384735, 275425949243301, 291667064279714, 286958161406148],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:11
        }
        // Description: 'Who can see posts you\'ve been tagged in on your timeline'
    }, {
        ID: 34,
        FixRelated: {
            type: 'privacy_update',
            id: '8787370733',
            valueSet: [300645083384735, 275425949243301, 291667064279714, 286958161406148],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:11
        }
        // Description: 'Who can see what others post on your timeline'
    }, {
        ID: 35,
        FixRelated: {
            type: 'taggingReview',
            valueSet: [1, 0],
            url: '/ajax/settings/tagging/review.php'
        }
        // Description: 'Review tags people add to your own posts before the tags appear on Facebook'
    }, {
        ID: 36,
        FixRelated: {
            type: 'tagSuggestion',
            valueSet: [1, 0],
            url: '/ajax/settings/tagging/suggestions.php'
        }
        // Description: 'Who sees tag suggestions when photos that look like you are uploaded?'
    }, {
        ID: 81,
        FixRelated: {
            type: 'friends_share',
            valueSet: [0],
            url: '/settings/applications/platform_friends_share/submit/'
        }
        // Description: 'Apps others use'
    }, {
        ID: 82,
        FixRelated: {
            type: 'instant_connect',
            id: '8787530733',
            valueSet: [0, 1],
            url: '/ajax/settings_page/instant_connect.php'
        }
        // Description: 'Instant personalization'
    }, {
        ID: 83,
        FixRelated: {
            type: 'simple_save',
            id: '8787700733',
            valueSet: [80, 50, 40, 10],
            url: '/ajax/privacy/simple_save.php'
        }
        // Description: 'Old versions of Facebook for mobile'
    }];

    var FixHelper = function() {
        this.PROTOCOL_DOMAIN = PUtil.checkPage.IsFacebook() ? window.location.protocol + '//' + window.location.host : 'https://www.facebook.com';
        this.Constants = Constants;
    };
    FixHelper.prototype.logHeaderSendData = '[Facebook Fix -> send data]';
    FixHelper.prototype.logHeaderHandleResponseData = '[Facebook Fix -> handle response data]';
    FixHelper.prototype.getSendData = function(id, value, userID, fb_dtsg, appID, bDetele) {
        var params = {
            'type' : 'POST',
            'data' : null,
            'dataType' : 'html',
            'url' : null
        };

        for (var i = 0; i < this.Constants.length; i++) {
            if (this.Constants[i]['ID'] == id) {
                var dataSet = this.Constants[i]['FixRelated'];
                break;
            }
        }
        
        // set url
        params.url = this.PROTOCOL_DOMAIN;
        params.url += dataSet.url;
        // set form data

        switch (dataSet.type) {
            case 'simple_save':
                params.data = this.postSimpleSave(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'privacy_update':
                this.postPrivacyUpdate(id, value, dataSet, userID, fb_dtsg, params);
                break;
            case 'timelineReview':
                params.data = this.postTimeLineReview(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'taggingReview':
                params.data = this.postTaggingReview(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'tagSuggestion':
                params.data = this.postSuggestionReview(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'public_search':
                params.data = this.postPublicSearch(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'instant_connect':
                params.data = this.postInstantConnect(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'friends_share':
                params.data = this.postFriendsShare(id, value, dataSet, userID, fb_dtsg);
                break;
        }

        new SendDataLogger(FixHelper.logHeaderSendData + ' : ' + id, params).getLog();
        return params;
    };
    FixHelper.prototype.handleResponse = function(id, value, data) {
        new ResponseHandlerLogger(FixHelper.logHeaderHandleResponseData + ', ID : ' + id + ', value : ' + value, data).getLog();
        var fixResult = PUtil.cloneObj(FacebookFixResultsTemplate);

        fixResult['id'] = id;
        fixResult['value'] = value;

        fixResult['data'] = data;
        return fixResult;
    };
    FixHelper.prototype.getValidFixValueByID = function(id) {
        for (var i = 0; i < this.Constants.length; i++) {
            if (this.Constants[i]['ID'] == id) {
                return FacebookScanResultsTemplate[i]['possibleFixValue'];
            }
        }
    };
    FixHelper.prototype.isValidFixValue = function(id, value) {
        var possibleValueList = this.getValidFixValueByID(id);
        for (var i = 0; i < possibleValueList.length; i++) {
            if (value == possibleValueList[i]) {
                return true;
            }
        }
        return false;
    };

    FixHelper.prototype.getQueryString = function(data) {
        var key;
        var result = '';
        for (key in data) {
            result += '&';
            result += key;
            result += '=';
            result += data[key];
        }

        return encodeURI(result).substr(1);
    };

    FixHelper.prototype.getTtstamp = function(fb_dtsg) {
        if(!fb_dtsg) {
            return "";
        }
        var v = "";
        var ttstamp = "";
        for (var w = 0; w < fb_dtsg.length; w++) { 
            v += fb_dtsg.charCodeAt(w);
            ttstamp = "2" + v;
        }
        return ttstamp;
    };

    FixHelper.prototype.postPrivacyUpdate = function(id, value, dataSet, userID, fb_dtsg, params) {
        var data = {
            __a: '1',              //Magic number, as Facebook's post param
            __user: userID,
            fb_dtsg: fb_dtsg,            
            __req: "a",              //Magic number, as Facebook's post param
            ttstamp:this.getTtstamp(fb_dtsg),
            __rev: 1747572           //Magic number, as Facebook's post param
        };
        params.data = data;
        params.url = dataSet.url + "&privacy_fbid=" + dataSet.id + "&post_param=" + dataSet.valueSet[value] + "&render_location=" + dataSet.render;
    };
    
    FixHelper.prototype.postSimpleSave = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            fb_dtsg: fb_dtsg,
            id: dataSet.id,
            source:"privacy_settings_page"
        };

        var audience_value = {
        };

        audience_value[dataSet.id] = {
            'value' : dataSet.valueSet[value]
        };

        data['audience_json'] = JSON.stringify(audience_value);
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);

        return data;
    };

    FixHelper.prototype.postTimeLineReview = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            tag_approval_enabled: dataSet.valueSet[value],
            fb_dtsg: fb_dtsg
        };

        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };

    FixHelper.prototype.postTaggingReview = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            tag_review_enabled: dataSet.valueSet[value],
            fb_dtsg: fb_dtsg
        };

        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };
    
    FixHelper.prototype.postSuggestionReview = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            tag_suggestion_enabled: dataSet.valueSet[value],
            fb_dtsg: fb_dtsg
        };

        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };

    FixHelper.prototype.postPublicSearch = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            el: 'search_filter_public',
            fb_dtsg: fb_dtsg,
            'public' : dataSet.valueSet[value],
            __req: '1'
        };
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };

    FixHelper.prototype.postInstantConnect = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            el: 'instant_personalization_checkbox',
            fb_dtsg: fb_dtsg,
            'opt_in' : dataSet.valueSet[value],
            __req: '1'
        };
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };

    FixHelper.prototype.postFriendsShare = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            fb_dtsg: fb_dtsg,
            __req: '3'
        };
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };

    window.FacebookFixHelper = FixHelper;
})();


/*
    FixerHelper_Under18
*/
(function() {'use strict';

    var Constants = [{
        ID: 20,
        FixRelated: { 
            type: 'privacy_update',
            id: '0',
            valueSet: [291667064279714, 275425949243301, 286958161406148],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:22
        }
        // Description: 'Who can see your future posts?'
    }, {
        ID: 22,
        FixRelated: {
            type: 'privacy_update',
            id: '8787820733',
            valueSet: [300645083384735, 275425949243301, 291667064279714],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:11
        }
        // Description: 'Who can look you up using the email address you provided?'
    }, {
        ID: 23,
        FixRelated: {
            type: 'privacy_update',
            id: '8787815733',
            valueSet: [300645083384735, 275425949243301, 291667064279714],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:11
        }
        // Description: 'Who can look you up using the phone number you provided?'
    }, {
        ID: 24,
        FixRelated: {
            type: 'public_search',
            valueSet: [0, 1],
            url: '/ajax/settings_page/search_filters.php'
        }
        // Description: 'Let other search engines link to your timeline'
    }, {
        ID: 31,
        FixRelated: {
            type: 'timelineReview',
            valueSet: [1, 0],
            url: '/ajax/settings/timeline/review.php'
        }
        // Description: 'Review posts friends tag you in before they appear on your timeline'
    }, {
        ID: 33,
        FixRelated: {
            type: 'privacy_update',
            id: '8787530733',
            valueSet: [275425949243301, 291667064279714, 286958161406148],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:11
        }
        // Description: 'Who can see posts you\'ve been tagged in on your timeline'
    }, {
        ID: 34,
        FixRelated: {
            type: 'privacy_update',
            id: '8787370733',
            valueSet: [275425949243301, 291667064279714, 286958161406148],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=true&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&tag_expansion_button=friends_of_tagged',
            render:11
        }
        // Description: 'Who can see what others post on your timeline'
    }, {
        ID: 35,
        FixRelated: {
            type: 'taggingReview',
            valueSet: [1, 0],
            url: '/ajax/settings/tagging/review.php'
        }
        // Description: 'Review tags people add to your own posts before the tags appear on Facebook'
    }, {
        ID: 36,
        FixRelated: {
            type: 'tagSuggestion',
            valueSet: [1, 0],
            url: '/ajax/settings/tagging/suggestions.php'
        }
        // Description: 'Who sees tag suggestions when photos that look like you are uploaded?'
    }, {
        ID: 81,
        FixRelated: {
            type: 'friends_share',
            valueSet: [0],
            url: '/settings/applications/platform_friends_share/submit/'
        }
        // Description: 'Apps others use'
    }, {
        ID: 82,
        FixRelated: {
            type: 'instant_connect',
            id: '8787530733',
            valueSet: [0, 1],
            url: '/ajax/settings_page/instant_connect.php'
        }
        // Description: 'Instant personalization'
    }, {
        ID: 83,
        FixRelated: {
            type: 'simple_save',
            id: '8787700733',
            valueSet: [50, 40, 10],
            url: '/ajax/privacy/simple_save.php'
        }
        // Description: 'Instant personalization'
    }];

    var FixHelper = function() {
        this.Constants = Constants;
    };
    
    FixHelper.prototype = new FacebookFixHelper();

    window.FacebookFixHelper_Under18 = FixHelper;
})();
